/* sudoku-cell.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
typedef struct _Block10Data Block10Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
	gboolean initialized_earmarks;
	gboolean _initialize_earmarks;
};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
	gboolean is_earmark;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* event,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* event,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
static void sudoku_cell_cell_changed_cb (SudokuCell* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self);
static void __lambda9_ (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
static void ___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda7_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCell* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_initialize_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
	return result;
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
}

static void
_sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                       gint row,
                                                       gint col,
                                                       gint old_val,
                                                       gint new_val,
                                                       gpointer self)
{
	sudoku_cell_cell_changed_cb ((SudokuCell*) self, row, col, old_val, new_val);
}

static void
__lambda9_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->popover;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkPopover* _tmp3_;
		_tmp3_ = self->popover;
		gtk_popover_set_child (_tmp3_, NULL);
		sudoku_cell_check_warnings (self);
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
}

static void
___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
	__lambda9_ ((SudokuCell*) self);
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkGestureClick* _tmp5_;
	GtkEventController* _tmp6_;
	GtkGestureLongPress* _tmp7_;
	GtkEventController* _tmp8_;
	GtkEventControllerKey* _tmp9_;
	GtkEventController* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureLongPress* _tmp12_;
	GtkGestureLongPress* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkEventControllerKey* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkLabel* _tmp17_;
	gint num = 0;
	GtkPopover* _tmp37_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp38_;
	GtkEventControllerKey* _tmp39_;
	GtkEventControllerKey* _tmp40_;
	GtkWidget* _tmp41_ = NULL;
	GtkPopover* _tmp42_;
	GtkPopover* _tmp45_;
	g_return_val_if_fail (*game != NULL, NULL);
	self = (SudokuCell*) g_object_new (object_type, NULL);
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
	self->priv->row = row;
	self->priv->col = col;
	_tmp0_ = _g_object_ref0 (*game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	_tmp1_ = (*game)->board;
	sudoku_cell_set_value (self, sudoku_board_get (_tmp1_, row, col));
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	_tmp2_ = sudoku_cell_get_is_fixed (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
	}
	_tmp4_ = self->priv->button_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp4_, (guint) 0);
	_tmp5_ = self->priv->button_controller;
	_tmp6_ = _g_object_ref0 ((GtkEventController*) _tmp5_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp6_);
	_tmp7_ = self->priv->long_press_controller;
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp8_);
	_tmp9_ = self->priv->key_controller;
	_tmp10_ = _g_object_ref0 ((GtkEventController*) _tmp9_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp10_);
	_tmp11_ = self->priv->button_controller;
	_tmp12_ = self->priv->long_press_controller;
	gtk_gesture_group ((GtkGesture*) _tmp11_, (GtkGesture*) _tmp12_);
	_tmp13_ = self->priv->long_press_controller;
	g_signal_connect_object (_tmp13_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
	_tmp14_ = self->priv->button_controller;
	g_signal_connect_object (_tmp14_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
	_tmp15_ = self->priv->key_controller;
	g_signal_connect_object (_tmp15_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
	_tmp16_ = self->priv->key_controller;
	g_signal_connect_object (_tmp16_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed, self, 0);
	_tmp17_ = self->priv->value_label;
	gtk_widget_set_parent ((GtkWidget*) _tmp17_, (GtkWidget*) self);
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = row_tmp;
					row_tmp = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				_tmp20_ = (*game)->board;
				_tmp21_ = sudoku_board_get_block_rows (_tmp20_);
				_tmp22_ = _tmp21_;
				if (!(row_tmp < _tmp22_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp23_ = FALSE;
						_tmp23_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							GtkLabel** _tmp29_;
							gint _tmp29__length1;
							gchar* _tmp30_;
							gchar* _tmp31_;
							GtkLabel* _tmp32_ = NULL;
							GtkLabel** _tmp33_;
							gint _tmp33__length1;
							GtkLabel* _tmp34_;
							GtkLabel** _tmp35_;
							gint _tmp35__length1;
							GtkLabel* _tmp36_;
							if (!_tmp23_) {
								gint _tmp24_;
								_tmp24_ = col_tmp;
								col_tmp = _tmp24_ + 1;
							}
							_tmp23_ = FALSE;
							_tmp25_ = (*game)->board;
							_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
							_tmp27_ = _tmp26_;
							if (!(col_tmp < _tmp27_)) {
								break;
							}
							_tmp28_ = num;
							num = _tmp28_ + 1;
							_tmp29_ = self->priv->earmark_labels;
							_tmp29__length1 = self->priv->earmark_labels_length1;
							_tmp30_ = g_strdup_printf ("%i", num);
							_tmp31_ = _tmp30_;
							_tmp32_ = (GtkLabel*) gtk_label_new (_tmp31_);
							gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
							g_object_ref_sink (_tmp32_);
							_g_object_unref0 (_tmp29_[num - 1]);
							_tmp29_[num - 1] = _tmp32_;
							_g_free0 (_tmp31_);
							_tmp33_ = self->priv->earmark_labels;
							_tmp33__length1 = self->priv->earmark_labels_length1;
							_tmp34_ = _tmp33_[num - 1];
							gtk_widget_set_parent ((GtkWidget*) _tmp34_, (GtkWidget*) self);
							_tmp35_ = self->priv->earmark_labels;
							_tmp35__length1 = self->priv->earmark_labels_length1;
							_tmp36_ = _tmp35_[num - 1];
							gtk_widget_add_css_class ((GtkWidget*) _tmp36_, "earmark");
						}
					}
				}
			}
		}
	}
	_tmp37_ = self->popover;
	gtk_widget_set_parent ((GtkWidget*) _tmp37_, (GtkWidget*) self);
	_tmp38_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	popover_controller = _tmp38_;
	_tmp39_ = popover_controller;
	g_signal_connect_object (_tmp39_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
	_tmp40_ = popover_controller;
	g_signal_connect_object (_tmp40_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
	_tmp42_ = self->popover;
	_tmp41_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp42_) : NULL;
	if (_tmp41_ != NULL) {
		GtkEventControllerKey* _tmp43_;
		GtkEventController* _tmp44_;
		_tmp43_ = popover_controller;
		_tmp44_ = _g_object_ref0 ((GtkEventController*) _tmp43_);
		gtk_widget_add_controller (_tmp41_, _tmp44_);
	}
	_tmp45_ = self->popover;
	g_signal_connect_object (_tmp45_, "closed", (GCallback) ___lambda9__gtk_popover_closed, self, 0);
	sudoku_cell_get_visible_earmarks (self);
	_g_object_unref0 (popover_controller);
	return self;
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
}

static void
sudoku_cell_cell_changed_cb (SudokuCell* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (row == self->priv->row) {
		_tmp0_ = col == self->priv->col;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		sudoku_cell_set_value (self, new_val);
		g_object_notify ((GObject*) self, "value");
		sudoku_cell_get_visible_earmarks (self);
	}
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (keyval == GDK_KEY_Control_L) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = keyval == GDK_KEY_Control_R;
	}
	if (_tmp0_) {
		self->priv->control_key_pressed = TRUE;
	}
	result = FALSE;
	return result;
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	gboolean _tmp8_ = FALSE;
	gint key = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->game;
	if (_tmp1_->mode == GAME_MODE_PLAY) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = sudoku_cell_get_is_fixed (self);
		_tmp4_ = _tmp3_;
		if (_tmp4_) {
			_tmp2_ = TRUE;
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
			_tmp5_ = self->priv->game;
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp2_ = _tmp7_;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	if (keyval == GDK_KEY_Control_L) {
		_tmp8_ = TRUE;
	} else {
		_tmp8_ = keyval == GDK_KEY_Control_R;
	}
	if (_tmp8_) {
		self->priv->control_key_pressed = FALSE;
		sudoku_cell_check_warnings (self);
	}
	key = sudoku_cell_get_key_number (self, keyval);
	if (key >= 1) {
		_tmp9_ = key <= 9;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp10_;
		GtkWidget* _tmp11_;
		NumberPicker* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GtkPopover* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		gboolean want_earmark = FALSE;
		gboolean _tmp21_ = FALSE;
		_tmp10_ = self->popover;
		_tmp11_ = gtk_popover_get_child (_tmp10_);
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_NUMBER_PICKER, NumberPicker));
		number_picker = _tmp12_;
		_tmp16_ = self->popover;
		_tmp17_ = gtk_widget_get_visible ((GtkWidget*) _tmp16_);
		_tmp18_ = _tmp17_;
		if (_tmp18_) {
			NumberPicker* _tmp19_;
			_tmp19_ = number_picker;
			_tmp15_ = _tmp19_ != NULL;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			NumberPicker* _tmp20_;
			_tmp20_ = number_picker;
			_tmp14_ = _tmp20_->is_earmark;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			_tmp13_ = TRUE;
		} else {
			_tmp13_ = (state & GDK_CONTROL_MASK) > 0;
		}
		want_earmark = _tmp13_;
		if (want_earmark) {
			SudokuGame* _tmp22_;
			_tmp22_ = self->priv->game;
			_tmp21_ = _tmp22_->mode == GAME_MODE_PLAY;
		} else {
			_tmp21_ = FALSE;
		}
		if (_tmp21_) {
			gboolean new_state = FALSE;
			SudokuGame* _tmp23_;
			SudokuBoard* _tmp24_;
			gboolean _tmp25_ = FALSE;
			NumberPicker* _tmp26_;
			_tmp23_ = self->priv->game;
			_tmp24_ = _tmp23_->board;
			new_state = !sudoku_board_is_earmark_enabled (_tmp24_, self->priv->row, self->priv->col, key);
			_tmp26_ = number_picker;
			if (_tmp26_ != NULL) {
				NumberPicker* _tmp27_;
				_tmp27_ = number_picker;
				_tmp25_ = _tmp27_->is_earmark;
			} else {
				_tmp25_ = FALSE;
			}
			if (_tmp25_) {
				NumberPicker* _tmp28_;
				_tmp28_ = number_picker;
				number_picker_set_earmark (_tmp28_, self->priv->row, self->priv->col, key - 1, new_state);
			} else {
				SudokuGame* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				if (new_state) {
					SudokuGame* _tmp29_;
					_tmp29_ = self->priv->game;
					sudoku_game_enable_earmark (_tmp29_, self->priv->row, self->priv->col, key);
				} else {
					SudokuGame* _tmp30_;
					_tmp30_ = self->priv->game;
					sudoku_game_disable_earmark (_tmp30_, self->priv->row, self->priv->col, key);
				}
				_tmp31_ = self->priv->game;
				_tmp32_ = sudoku_cell_get_value (self);
				_tmp33_ = _tmp32_;
				_tmp34_ = sudoku_cell_get_value (self);
				_tmp35_ = _tmp34_;
				g_signal_emit_by_name (_tmp31_, "cell-changed", self->priv->row, self->priv->col, _tmp33_, _tmp35_);
			}
		} else {
			SudokuGame* _tmp36_;
			SudokuBoard* _tmp37_;
			sudoku_cell_set_value (self, key);
			_tmp36_ = self->priv->game;
			_tmp37_ = _tmp36_->board;
			sudoku_board_disable_all_earmarks (_tmp37_, self->priv->row, self->priv->col);
		}
		_g_object_unref0 (number_picker);
		return;
	}
	if (key == 0) {
		_tmp39_ = TRUE;
	} else {
		_tmp39_ = keyval == GDK_KEY_BackSpace;
	}
	if (_tmp39_) {
		_tmp38_ = TRUE;
	} else {
		_tmp38_ = keyval == GDK_KEY_Delete;
	}
	if (_tmp38_) {
		sudoku_cell_set_value (self, 0);
		g_object_notify ((GObject*) self, "value");
		return;
	}
	if (keyval == GDK_KEY_space) {
		_tmp41_ = TRUE;
	} else {
		_tmp41_ = keyval == GDK_KEY_Return;
	}
	if (_tmp41_) {
		_tmp40_ = TRUE;
	} else {
		_tmp40_ = keyval == GDK_KEY_KP_Enter;
	}
	if (_tmp40_) {
		GtkPopover* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp44_;
		_tmp42_ = self->popover;
		_tmp43_ = gtk_widget_get_visible ((GtkWidget*) _tmp42_);
		_tmp44_ = _tmp43_;
		if (_tmp44_) {
			return;
		}
		sudoku_cell_show_number_picker (self);
		return;
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* event,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_tmp1_ = self->priv->game;
	if (_tmp1_->mode == GAME_MODE_PLAY) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = sudoku_cell_get_is_fixed (self);
		_tmp4_ = _tmp3_;
		if (_tmp4_) {
			_tmp2_ = TRUE;
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
			_tmp5_ = self->priv->game;
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp2_ = _tmp7_;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	sudoku_cell_show_earmark_picker (self);
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* event,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
	_tmp4_ = self->priv->game;
	if (_tmp4_->mode == GAME_MODE_PLAY) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp6_ = sudoku_cell_get_is_fixed (self);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			_tmp5_ = TRUE;
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp8_ = self->priv->game;
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp5_ = _tmp10_;
		}
		_tmp3_ = _tmp5_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		return;
	}
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_PRIMARY)) {
		gboolean _tmp11_ = FALSE;
		if (!self->show_possibilities) {
			GdkEventSequence* _tmp12_;
			GdkEvent* _tmp13_;
			_tmp12_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) event);
			_tmp13_ = gtk_gesture_get_last_event ((GtkGesture*) event, _tmp12_);
			_tmp11_ = (gdk_event_get_modifier_state (_tmp13_) & GDK_CONTROL_MASK) > 0;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			sudoku_cell_show_earmark_picker (self);
		} else {
			sudoku_cell_show_number_picker (self);
		}
	} else {
		gboolean _tmp14_ = FALSE;
		if (!self->show_possibilities) {
			_tmp14_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_SECONDARY);
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			sudoku_cell_show_earmark_picker (self);
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	switch (keyval) {
		case GDK_KEY_0:
		case GDK_KEY_KP_0:
		{
			result = 0;
			return result;
		}
		case GDK_KEY_1:
		case GDK_KEY_KP_1:
		{
			result = 1;
			return result;
		}
		case GDK_KEY_2:
		case GDK_KEY_KP_2:
		{
			result = 2;
			return result;
		}
		case GDK_KEY_3:
		case GDK_KEY_KP_3:
		{
			result = 3;
			return result;
		}
		case GDK_KEY_4:
		case GDK_KEY_KP_4:
		{
			result = 4;
			return result;
		}
		case GDK_KEY_5:
		case GDK_KEY_KP_5:
		{
			result = 5;
			return result;
		}
		case GDK_KEY_6:
		case GDK_KEY_KP_6:
		{
			result = 6;
			return result;
		}
		case GDK_KEY_7:
		case GDK_KEY_KP_7:
		{
			result = 7;
			return result;
		}
		case GDK_KEY_8:
		case GDK_KEY_KP_8:
		{
			result = 8;
			return result;
		}
		case GDK_KEY_9:
		case GDK_KEY_KP_9:
		{
			result = 9;
			return result;
		}
		default:
		{
			result = -1;
			return result;
		}
	}
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gint num = 0;
	g_return_if_fail (self != NULL);
	marks = NULL;
	marks_length1 = 0;
	_marks_size_ = marks_length1;
	if (!self->show_possibilities) {
		SudokuGame* _tmp18_;
		SudokuBoard* _tmp19_;
		gint _tmp20_ = 0;
		gboolean* _tmp21_;
		if (!self->priv->initialized_earmarks) {
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
			if (self->priv->_initialize_earmarks) {
				SudokuGame* _tmp2_;
				_tmp2_ = self->priv->game;
				_tmp1_ = _tmp2_->mode == GAME_MODE_PLAY;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gdouble _tmp5_;
				gdouble _tmp6_;
				_tmp3_ = self->priv->game;
				_tmp4_ = _tmp3_->board;
				_tmp5_ = sudoku_board_get_previous_played_time (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp0_ = _tmp6_ == 0.0;
			} else {
				_tmp0_ = FALSE;
			}
			if (_tmp0_) {
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_ = 0;
				gboolean* _tmp10_;
				_tmp7_ = self->priv->game;
				_tmp8_ = _tmp7_->board;
				_tmp10_ = sudoku_board_get_possibilities_as_bool_array (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
				marks = (g_free (marks), NULL);
				marks = _tmp10_;
				marks_length1 = _tmp9_;
				_marks_size_ = marks_length1;
				{
					gint num = 0;
					num = 1;
					{
						gboolean _tmp11_ = FALSE;
						_tmp11_ = TRUE;
						while (TRUE) {
							gboolean* _tmp13_;
							gint _tmp13__length1;
							gboolean* _tmp14_;
							gint _tmp14__length1;
							gboolean _tmp15_;
							if (!_tmp11_) {
								gint _tmp12_;
								_tmp12_ = num;
								num = _tmp12_ + 1;
							}
							_tmp11_ = FALSE;
							_tmp13_ = marks;
							_tmp13__length1 = marks_length1;
							if (!(num <= _tmp13__length1)) {
								break;
							}
							_tmp14_ = marks;
							_tmp14__length1 = marks_length1;
							_tmp15_ = _tmp14_[num - 1];
							if (_tmp15_) {
								SudokuGame* _tmp16_;
								SudokuBoard* _tmp17_;
								_tmp16_ = self->priv->game;
								_tmp17_ = _tmp16_->board;
								sudoku_board_enable_earmark (_tmp17_, self->priv->row, self->priv->col, num);
							}
						}
					}
				}
			}
			self->priv->initialized_earmarks = TRUE;
		}
		_tmp18_ = self->priv->game;
		_tmp19_ = _tmp18_->board;
		_tmp21_ = sudoku_board_get_earmarks (_tmp19_, self->priv->row, self->priv->col, &_tmp20_);
		marks = (g_free (marks), NULL);
		marks = _tmp21_;
		marks_length1 = _tmp20_;
		_marks_size_ = marks_length1;
	} else {
		gint _tmp22_;
		gint _tmp23_;
		_tmp22_ = sudoku_cell_get_value (self);
		_tmp23_ = _tmp22_;
		if (_tmp23_ == 0) {
			SudokuGame* _tmp24_;
			SudokuBoard* _tmp25_;
			gint _tmp26_ = 0;
			gboolean* _tmp27_;
			_tmp24_ = self->priv->game;
			_tmp25_ = _tmp24_->board;
			_tmp27_ = sudoku_board_get_possibilities_as_bool_array (_tmp25_, self->priv->row, self->priv->col, &_tmp26_);
			marks = (g_free (marks), NULL);
			marks = _tmp27_;
			marks_length1 = _tmp26_;
			_marks_size_ = marks_length1;
		}
	}
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				if (!_tmp28_) {
					gint _tmp29_;
					_tmp29_ = row_tmp;
					row_tmp = _tmp29_ + 1;
				}
				_tmp28_ = FALSE;
				_tmp30_ = self->priv->game;
				_tmp31_ = _tmp30_->board;
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
				_tmp33_ = _tmp32_;
				if (!(row_tmp < _tmp33_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp34_ = FALSE;
						_tmp34_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gboolean _tmp41_ = FALSE;
							gboolean* _tmp42_;
							gint _tmp42__length1;
							if (!_tmp34_) {
								gint _tmp35_;
								_tmp35_ = col_tmp;
								col_tmp = _tmp35_ + 1;
							}
							_tmp34_ = FALSE;
							_tmp36_ = self->priv->game;
							_tmp37_ = _tmp36_->board;
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
							_tmp39_ = _tmp38_;
							if (!(col_tmp < _tmp39_)) {
								break;
							}
							_tmp40_ = num;
							num = _tmp40_ + 1;
							_tmp42_ = marks;
							_tmp42__length1 = marks_length1;
							if (_tmp42_ == NULL) {
								_tmp41_ = TRUE;
							} else {
								gint _tmp43_;
								gint _tmp44_;
								_tmp43_ = sudoku_cell_get_value (self);
								_tmp44_ = _tmp43_;
								_tmp41_ = _tmp44_ != 0;
							}
							if (_tmp41_) {
								GtkLabel** _tmp45_;
								gint _tmp45__length1;
								GtkLabel* _tmp46_;
								_tmp45_ = self->priv->earmark_labels;
								_tmp45__length1 = self->priv->earmark_labels_length1;
								_tmp46_ = _tmp45_[num - 1];
								gtk_widget_set_visible ((GtkWidget*) _tmp46_, FALSE);
							} else {
								GtkLabel** _tmp47_;
								gint _tmp47__length1;
								GtkLabel* _tmp48_;
								gboolean* _tmp49_;
								gint _tmp49__length1;
								gboolean _tmp50_;
								_tmp47_ = self->priv->earmark_labels;
								_tmp47__length1 = self->priv->earmark_labels_length1;
								_tmp48_ = _tmp47_[num - 1];
								_tmp49_ = marks;
								_tmp49__length1 = marks_length1;
								_tmp50_ = _tmp49_[num - 1];
								gtk_widget_set_visible ((GtkWidget*) _tmp48_, _tmp50_);
							}
						}
					}
				}
			}
		}
	}
	marks = (g_free (marks), NULL);
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		SudokuCell* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->earmark_picker);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda7_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuGame* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	self = _data10_->self;
	if (state) {
		SudokuGame* _tmp0_;
		_tmp0_ = self->priv->game;
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
	} else {
		if (number == 0) {
			SudokuGame* _tmp1_;
			_tmp1_ = self->priv->game;
			sudoku_game_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
		} else {
			SudokuGame* _tmp2_;
			_tmp2_ = self->priv->game;
			sudoku_game_disable_earmark (_tmp2_, self->priv->row, self->priv->col, number);
		}
	}
	_tmp3_ = self->priv->game;
	_tmp4_ = _tmp3_->board;
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
		NumberPicker* _tmp5_;
		_tmp5_ = _data10_->earmark_picker;
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
	} else {
		NumberPicker* _tmp6_;
		_tmp6_ = _data10_->earmark_picker;
		number_picker_set_clear_button_enabled (_tmp6_, TRUE);
	}
	sudoku_cell_check_warnings (self);
	_tmp7_ = self->priv->game;
	_tmp8_ = sudoku_cell_get_value (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = sudoku_cell_get_value (self);
	_tmp11_ = _tmp10_;
	g_signal_emit_by_name (_tmp7_, "cell-changed", self->priv->row, self->priv->col, _tmp9_, _tmp11_);
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
	__lambda7_ (self, number, active);
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	Block10Data* _data10_;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	NumberPicker* _tmp6_;
	NumberPicker* _tmp7_;
	GtkPopover* _tmp8_;
	NumberPicker* _tmp9_;
	GtkPopover* _tmp10_;
	g_return_if_fail (self != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = self->priv->game;
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
	g_object_ref_sink (_tmp1_);
	_data10_->earmark_picker = _tmp1_;
	_tmp2_ = _data10_->earmark_picker;
	number_picker_set_clear_button_visibility (_tmp2_, TRUE);
	_tmp3_ = self->priv->game;
	_tmp4_ = _tmp3_->board;
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
		NumberPicker* _tmp5_;
		_tmp5_ = _data10_->earmark_picker;
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
	}
	_tmp6_ = _data10_->earmark_picker;
	g_signal_connect_data (_tmp6_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	_tmp7_ = _data10_->earmark_picker;
	number_picker_set_earmarks (_tmp7_, self->priv->row, self->priv->col);
	_tmp8_ = self->popover;
	_tmp9_ = _data10_->earmark_picker;
	gtk_popover_set_child (_tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = self->popover;
	gtk_popover_popup (_tmp10_);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static void
__lambda8_ (SudokuCell* self,
            NumberPicker* o,
            gint number)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuGame* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	g_return_if_fail (o != NULL);
	_tmp0_ = self->popover;
	gtk_popover_popdown (_tmp0_);
	sudoku_cell_set_value (self, number);
	if (number == 0) {
		g_object_notify ((GObject*) self, "value");
	}
	_tmp1_ = self->priv->game;
	_tmp2_ = _tmp1_->board;
	sudoku_board_disable_all_earmarks (_tmp2_, self->priv->row, self->priv->col);
	_tmp3_ = self->priv->game;
	_tmp4_ = sudoku_cell_get_value (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = sudoku_cell_get_value (self);
	_tmp7_ = _tmp6_;
	g_signal_emit_by_name (_tmp3_, "cell-changed", self->priv->row, self->priv->col, _tmp5_, _tmp7_);
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
	__lambda8_ ((SudokuCell*) self, _sender, number);
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	NumberPicker* number_picker = NULL;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = number_picker_new (&_tmp0_->board, FALSE);
	g_object_ref_sink (_tmp1_);
	number_picker = _tmp1_;
	g_signal_connect_object (number_picker, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
	_tmp2_ = sudoku_cell_get_value (self);
	_tmp3_ = _tmp2_;
	number_picker_set_clear_button_visibility (number_picker, _tmp3_ != 0);
	_tmp4_ = self->popover;
	gtk_popover_set_child (_tmp4_, (GtkWidget*) number_picker);
	_tmp5_ = self->popover;
	gtk_popover_popup (_tmp5_);
	_g_object_unref0 (number_picker);
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint solution = 0;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* marks = NULL;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_ = 0;
	gboolean* _tmp5_;
	gint marks_length1;
	gint _marks_size_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_;
	gboolean _tmp27_;
	gint _tmp32_;
	gint _tmp33_;
	g_return_if_fail (self != NULL);
	_error_ = FALSE;
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	solution = sudoku_board_get_solution (_tmp1_, self->priv->row, self->priv->col);
	_tmp2_ = self->priv->game;
	_tmp3_ = _tmp2_->board;
	_tmp5_ = sudoku_board_get_earmarks (_tmp3_, self->priv->row, self->priv->col, &_tmp4_);
	marks = _tmp5_;
	marks_length1 = _tmp4_;
	_marks_size_ = marks_length1;
	_tmp8_ = sudoku_cell_get_show_warnings (self);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		gint _tmp10_;
		gint _tmp11_;
		_tmp10_ = sudoku_cell_get_value (self);
		_tmp11_ = _tmp10_;
		_tmp7_ = _tmp11_ == 0;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		SudokuGame* _tmp12_;
		SudokuBoard* _tmp13_;
		_tmp12_ = self->priv->game;
		_tmp13_ = _tmp12_->board;
		_tmp6_ = sudoku_board_count_possibilities (_tmp13_, self->priv->row, self->priv->col) == 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GtkLabel* _tmp14_;
		_tmp14_ = self->priv->value_label;
		gtk_label_set_label (_tmp14_, "X");
	} else {
		GtkLabel* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp15_ = self->priv->value_label;
		_tmp16_ = sudoku_cell_get_value (self);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strdup_printf ("%i", _tmp17_);
		_tmp19_ = _tmp18_;
		gtk_label_set_label (_tmp15_, _tmp19_);
		_g_free0 (_tmp19_);
	}
	if (sudoku_cell_warn_incorrect_solution (self)) {
		gint _tmp21_;
		gint _tmp22_;
		_tmp21_ = sudoku_cell_get_value (self);
		_tmp22_ = _tmp21_;
		_tmp20_ = _tmp22_ != 0;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		gint _tmp23_;
		gint _tmp24_;
		_tmp23_ = sudoku_cell_get_value (self);
		_tmp24_ = _tmp23_;
		_error_ = _tmp24_ != solution;
	}
	_tmp26_ = sudoku_cell_get_show_warnings (self);
	_tmp27_ = _tmp26_;
	if (_tmp27_) {
		SudokuGame* _tmp28_;
		SudokuBoard* _tmp29_;
		GeeSet* _tmp30_;
		Coord _tmp31_ = {0};
		_tmp28_ = self->priv->game;
		_tmp29_ = _tmp28_->board;
		_tmp30_ = _tmp29_->broken_coords;
		coord_init (&_tmp31_, self->priv->row, self->priv->col);
		_tmp25_ = gee_collection_contains ((GeeCollection*) _tmp30_, &_tmp31_);
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		_error_ = TRUE;
	}
	if (_error_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
	}
	_tmp32_ = sudoku_cell_get_value (self);
	_tmp33_ = _tmp32_;
	if (_tmp33_ != 0) {
		marks = (g_free (marks), NULL);
		return;
	}
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp34_ = FALSE;
			_tmp34_ = TRUE;
			while (TRUE) {
				gboolean* _tmp36_;
				gint _tmp36__length1;
				gboolean* _tmp37_;
				gint _tmp37__length1;
				gboolean _tmp38_;
				if (!_tmp34_) {
					gint _tmp35_;
					_tmp35_ = num;
					num = _tmp35_ + 1;
				}
				_tmp34_ = FALSE;
				_tmp36_ = marks;
				_tmp36__length1 = marks_length1;
				if (!(num <= _tmp36__length1)) {
					break;
				}
				_tmp37_ = marks;
				_tmp37__length1 = marks_length1;
				_tmp38_ = _tmp37_[num - 1];
				if (_tmp38_) {
					gboolean _tmp39_ = FALSE;
					gboolean _tmp40_ = FALSE;
					gboolean _tmp41_;
					gboolean _tmp42_;
					_tmp41_ = sudoku_cell_get_show_warnings (self);
					_tmp42_ = _tmp41_;
					if (_tmp42_) {
						SudokuGame* _tmp43_;
						SudokuBoard* _tmp44_;
						_tmp43_ = self->priv->game;
						_tmp44_ = _tmp43_->board;
						_tmp40_ = !sudoku_board_is_possible (_tmp44_, self->priv->row, self->priv->col, num);
					} else {
						_tmp40_ = FALSE;
					}
					if (_tmp40_) {
						_tmp39_ = TRUE;
					} else {
						gboolean _tmp45_ = FALSE;
						if (sudoku_cell_warn_incorrect_solution (self)) {
							_tmp45_ = num != solution;
						} else {
							_tmp45_ = FALSE;
						}
						_tmp39_ = _tmp45_;
					}
					if (_tmp39_) {
						GtkLabel** _tmp46_;
						gint _tmp46__length1;
						GtkLabel* _tmp47_;
						_tmp46_ = self->priv->earmark_labels;
						_tmp46__length1 = self->priv->earmark_labels_length1;
						_tmp47_ = _tmp46_[num - 1];
						gtk_widget_add_css_class ((GtkWidget*) _tmp47_, "error");
					} else {
						GtkLabel** _tmp48_;
						gint _tmp48__length1;
						GtkLabel* _tmp49_;
						_tmp48_ = self->priv->earmark_labels;
						_tmp48__length1 = self->priv->earmark_labels_length1;
						_tmp49_ = _tmp48_[num - 1];
						gtk_widget_remove_css_class ((GtkWidget*) _tmp49_, "error");
					}
				}
			}
		}
	}
	marks = (g_free (marks), NULL);
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp1_ = !self->priv->control_key_pressed;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		_tmp4_ = self->priv->game;
		_tmp5_ = _tmp4_->board;
		_tmp0_ = sudoku_board_solved (_tmp5_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
	self = (SudokuCell*) base;
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp0_ = self->priv->value_label;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
	return self ? gsk_transform_ref (self) : NULL;
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp1_;
	graphene_point_t _tmp2_ = {0};
	graphene_point_t _tmp3_;
	GskTransform* _tmp4_;
	GtkLabel* _tmp5_;
	GskTransform* _tmp6_;
	GskTransform* _tmp7_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp8_;
	SudokuBoard* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	SudokuGame* _tmp12_;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint num = 0;
	self = (SudokuCell*) base;
	_tmp0_ = self->popover;
	gtk_popover_present (_tmp0_);
	value_height = MIN (width, height);
	value_width = value_height;
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
	_tmp1_ = gsk_transform_new ();
	memset (&_tmp2_, 0, sizeof (graphene_point_t));
	_tmp3_ = *graphene_point_init (&_tmp2_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
	_tmp4_ = gsk_transform_translate (_tmp1_, &_tmp3_);
	center = _tmp4_;
	_tmp5_ = self->priv->value_label;
	_tmp6_ = center;
	_tmp7_ = _gsk_transform_ref0 (_tmp6_);
	gtk_widget_allocate ((GtkWidget*) _tmp5_, value_width, value_height, baseline, _tmp7_);
	_tmp8_ = self->priv->game;
	_tmp9_ = _tmp8_->board;
	_tmp10_ = sudoku_board_get_block_cols (_tmp9_);
	_tmp11_ = _tmp10_;
	earmark_width = width / _tmp11_;
	_tmp12_ = self->priv->game;
	_tmp13_ = _tmp12_->board;
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
	_tmp15_ = _tmp14_;
	earmark_height = height / _tmp15_;
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp16_ = FALSE;
			_tmp16_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp18_;
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				if (!_tmp16_) {
					gint _tmp17_;
					_tmp17_ = row_tmp;
					row_tmp = _tmp17_ + 1;
				}
				_tmp16_ = FALSE;
				_tmp18_ = self->priv->game;
				_tmp19_ = _tmp18_->board;
				_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
				_tmp21_ = _tmp20_;
				if (!(row_tmp < _tmp21_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp22_ = FALSE;
						_tmp22_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp24_;
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							GtkLabel** _tmp29_;
							gint _tmp29__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp30_;
							graphene_point_t _tmp31_ = {0};
							SudokuGame* _tmp32_;
							SudokuBoard* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							graphene_point_t _tmp36_;
							GskTransform* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GskTransform* _tmp40_;
							GskTransform* _tmp41_;
							if (!_tmp22_) {
								gint _tmp23_;
								_tmp23_ = col_tmp;
								col_tmp = _tmp23_ + 1;
							}
							_tmp22_ = FALSE;
							_tmp24_ = self->priv->game;
							_tmp25_ = _tmp24_->board;
							_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
							_tmp27_ = _tmp26_;
							if (!(col_tmp < _tmp27_)) {
								break;
							}
							_tmp28_ = num;
							num = _tmp28_ + 1;
							_tmp29_ = self->priv->earmark_labels;
							_tmp29__length1 = self->priv->earmark_labels_length1;
							sudoku_cell_set_font_size (self, &_tmp29_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
							_tmp30_ = gsk_transform_new ();
							memset (&_tmp31_, 0, sizeof (graphene_point_t));
							_tmp32_ = self->priv->game;
							_tmp33_ = _tmp32_->board;
							_tmp34_ = sudoku_board_get_block_rows (_tmp33_);
							_tmp35_ = _tmp34_;
							_tmp36_ = *graphene_point_init (&_tmp31_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp35_ - row_tmp) - 1) * earmark_height));
							_tmp37_ = gsk_transform_translate (_tmp30_, &_tmp36_);
							earmark_position = _tmp37_;
							_tmp38_ = self->priv->earmark_labels;
							_tmp38__length1 = self->priv->earmark_labels_length1;
							_tmp39_ = _tmp38_[num - 1];
							_tmp40_ = earmark_position;
							_tmp41_ = _gsk_transform_ref0 (_tmp40_);
							gtk_widget_allocate ((GtkWidget*) _tmp39_, earmark_width, earmark_height, baseline, _tmp41_);
							_gsk_transform_unref0 (earmark_position);
						}
					}
				}
			}
		}
	}
	_gsk_transform_unref0 (center);
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
	return self ? pango_attr_list_ref (self) : NULL;
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (*label != NULL);
	_tmp0_ = gtk_label_get_attributes (*label);
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
	attr_list = _tmp1_;
	_tmp2_ = attr_list;
	if (_tmp2_ == NULL) {
		PangoAttrList* _tmp3_;
		_tmp3_ = pango_attr_list_new ();
		_pango_attr_list_unref0 (attr_list);
		attr_list = _tmp3_;
	}
	_tmp4_ = attr_list;
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
	pango_attr_list_change (_tmp4_, _tmp5_);
	_tmp6_ = attr_list;
	gtk_label_set_attributes (*label, _tmp6_);
	_pango_attr_list_unref0 (attr_list);
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
	return result;
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	GtkLabel* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SudokuGame* _tmp14_;
	g_return_if_fail (self != NULL);
	if (value != 0) {
		GtkLabel* _tmp0_;
		_tmp0_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
	} else {
		GtkLabel* _tmp1_;
		_tmp1_ = self->priv->value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
	}
	_tmp2_ = sudoku_cell_get_is_fixed (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		SudokuGame* _tmp4_;
		_tmp4_ = self->priv->game;
		if (_tmp4_->mode == GAME_MODE_PLAY) {
			return;
		}
	}
	if (value == 0) {
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		SudokuGame* _tmp8_;
		_tmp5_ = self->priv->game;
		_tmp6_ = _tmp5_->board;
		if (sudoku_board_get (_tmp6_, self->priv->row, self->priv->col) != 0) {
			SudokuGame* _tmp7_;
			_tmp7_ = self->priv->game;
			sudoku_game_remove (_tmp7_, self->priv->row, self->priv->col);
		}
		_tmp8_ = self->priv->game;
		if (_tmp8_->mode == GAME_MODE_PLAY) {
			return;
		}
	}
	_tmp9_ = self->priv->game;
	_tmp10_ = _tmp9_->board;
	if (value == sudoku_board_get (_tmp10_, self->priv->row, self->priv->col)) {
		return;
	}
	_tmp11_ = self->priv->value_label;
	_tmp12_ = g_strdup_printf ("%i", value);
	_tmp13_ = _tmp12_;
	gtk_label_set_label (_tmp11_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = self->priv->game;
	sudoku_game_insert (_tmp14_, self->priv->row, self->priv->col, value);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	_tmp2_ = _tmp1_->is_fixed;
	_tmp2__length1 = _tmp1_->is_fixed_length1;
	_tmp2__length2 = _tmp1_->is_fixed_length2;
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
	result = _tmp3_;
	return result;
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_selected;
	return result;
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_selected = value;
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighted_background;
	return result;
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlighted_background = value;
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighted_value;
	return result;
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->_highlighted_value = value;
	if (value) {
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_warnings;
	return result;
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_warnings = value;
	sudoku_cell_check_warnings (self);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_extra_warnings;
	return result;
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_extra_warnings = value;
	sudoku_cell_check_warnings (self);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
}

gboolean
sudoku_cell_get_initialize_earmarks (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_initialize_earmarks;
	return result;
}

void
sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_initialize_earmarks = value;
	sudoku_cell_get_visible_earmarks (self);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY]);
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkPopover* _tmp3_;
	GtkLabel* _tmp4_ = NULL;
	GtkLabel** _tmp5_;
	self->priv = sudoku_cell_get_instance_private (self);
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
	self->priv->button_controller = _tmp0_;
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
	self->priv->long_press_controller = _tmp1_;
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	self->priv->key_controller = _tmp2_;
	_tmp3_ = (GtkPopover*) gtk_popover_new ();
	g_object_ref_sink (_tmp3_);
	self->popover = _tmp3_;
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
	g_object_ref_sink (_tmp4_);
	self->priv->value_label = _tmp4_;
	_tmp5_ = g_new0 (GtkLabel*, 8 + 1);
	self->priv->earmark_labels = _tmp5_;
	self->priv->earmark_labels_length1 = 8;
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
	self->priv->_selected = FALSE;
	self->priv->_highlighted_background = FALSE;
	self->priv->_highlighted_value = FALSE;
	self->priv->_show_warnings = TRUE;
	self->priv->_show_extra_warnings = FALSE;
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
	_g_object_unref0 (self->priv->game);
	_g_object_unref0 (self->priv->button_controller);
	_g_object_unref0 (self->priv->long_press_controller);
	_g_object_unref0 (self->priv->key_controller);
	_g_object_unref0 (self->popover);
	_g_object_unref0 (self->priv->value_label);
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_VALUE_PROPERTY:
		g_value_set_int (value, sudoku_cell_get_value (self));
		break;
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
		break;
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
		break;
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
		break;
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_initialize_earmarks (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_VALUE_PROPERTY:
		sudoku_cell_set_value (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
		sudoku_cell_set_initialize_earmarks (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

