/* sudoku-view.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
	gint selected_row;
	gint selected_col;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block11Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN SudokuView* sudoku_view_new (gint frame_size,
                             SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   gint frame_size,
                                   SudokuGame* game);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda10_ (SudokuView* self);
static void ___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda11_ (Block12Data* _data12_);
static void sudoku_view_update_highlights (SudokuView* self);
static void _________lambda11__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda12_ (Block12Data* _data12_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda12__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
static void sudoku_view_clear_highlights (SudokuView* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_redraw (SudokuView* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static gboolean _sudoku_view___lambda13_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	if (self->selected_row >= 0) {
		_tmp0_ = self->selected_col >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		_tmp1_ = self->priv->cells;
		_tmp1__length1 = self->priv->cells_length1;
		_tmp1__length2 = self->priv->cells_length2;
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
		sudoku_cell_set_selected (_tmp2_, FALSE);
	}
	self->selected_row = cell_row;
	self->selected_col = cell_col;
	if (self->selected_row >= 0) {
		_tmp3_ = self->selected_col >= 0;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
		_tmp4_ = self->priv->cells;
		_tmp4__length1 = self->priv->cells_length1;
		_tmp4__length2 = self->priv->cells_length2;
		_tmp5_ = _tmp4_[(self->selected_row * _tmp4__length2) + self->selected_col];
		sudoku_cell_set_selected (_tmp5_, TRUE);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		SudokuView* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->game);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
	return self ? pango_attr_list_ref (self) : NULL;
}

static void
__lambda10_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	SudokuGame* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	_tmp0_ = self->priv->paused;
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
	attr_list = _tmp2_;
	_tmp3_ = attr_list;
	if (_tmp3_ == NULL) {
		PangoAttrList* _tmp4_;
		_tmp4_ = pango_attr_list_new ();
		_pango_attr_list_unref0 (attr_list);
		attr_list = _tmp4_;
	}
	_tmp5_ = attr_list;
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
	pango_attr_list_change (_tmp5_, _tmp6_);
	_tmp7_ = self->priv->paused;
	_tmp8_ = attr_list;
	gtk_label_set_attributes (_tmp7_, _tmp8_);
	_tmp9_ = self->game;
	_tmp10_ = sudoku_game_get_paused (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		GtkLabel* _tmp12_;
		_tmp12_ = self->priv->paused;
		gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
	} else {
		GtkLabel* _tmp13_;
		_tmp13_ = self->priv->paused;
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
	}
	_pango_attr_list_unref0 (attr_list);
}

static void
___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
	__lambda10_ ((SudokuView*) self);
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		SudokuView* self;
		self = _data12_->_data11_->self;
		_g_object_unref0 (_data12_->cell);
		block11_data_unref (_data12_->_data11_);
		_data12_->_data11_ = NULL;
		g_slice_free (Block12Data, _data12_);
	}
}

static void
________lambda11_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	SudokuCell* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	_data11_ = _data12_->_data11_;
	self = _data11_->self;
	_tmp0_ = sudoku_game_get_paused (_data11_->game);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp3_ = _data12_->cell;
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		_tmp2_ = TRUE;
	} else {
		SudokuCell* _tmp6_;
		GtkPopover* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp6_ = _data12_->cell;
		_tmp7_ = _tmp6_->popover;
		_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp2_ = _tmp9_;
	}
	if (_tmp2_) {
		sudoku_view_set_selected (self, _data12_->cell_row, _data12_->cell_col);
	} else {
		sudoku_view_set_selected (self, -1, -1);
	}
	sudoku_view_update_highlights (self);
}

static void
_________lambda11__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	________lambda11_ (self);
}

static void
________lambda12_ (Block12Data* _data12_,
                   GObject* s,
                   GParamSpec* p)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	_data11_ = _data12_->_data11_;
	self = _data11_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	if (self->priv->_show_possibilities) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = self->priv->_show_warnings;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = _data11_->game->board;
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->previous_board_broken_state;
	}
	if (_tmp0_) {
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = _data11_->game->board;
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
		_tmp8_ = _tmp7_;
		self->priv->previous_board_broken_state = _tmp8_;
	}
	sudoku_view_update_highlights (self);
}

static void
_________lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	________lambda12_ (self, _sender, pspec);
}

SudokuView*
sudoku_view_construct (GType object_type,
                       gint frame_size,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block11Data* _data11_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp2_;
	SudokuFrame* _tmp3_;
	SudokuFrame* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* _tmp7_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GtkGrid** _tmp19_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	SudokuBoard* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	SudokuCell** _tmp47_;
	GtkOverlay* _tmp79_;
	GtkLabel* _tmp80_;
	GtkOverlay* _tmp81_;
	GtkGrid* _tmp82_;
	GtkGrid* _tmp83_;
	GtkOverlay* _tmp84_;
	GtkLabel* _tmp85_;
	g_return_val_if_fail (game != NULL, NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (_data11_->game);
	_data11_->game = _tmp0_;
	self = (SudokuView*) g_object_new (object_type, NULL);
	_data11_->self = g_object_ref (self);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->overlay);
	self->priv->overlay = _tmp1_;
	_tmp2_ = self->priv->overlay;
	_tmp3_ = sudoku_frame_new ((GtkWidget*) _tmp2_);
	g_object_ref_sink (_tmp3_);
	frame = _tmp3_;
	_tmp4_ = frame;
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
	_tmp5_ = (GtkLabel*) gtk_label_new ("Paused");
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->paused);
	self->priv->paused = _tmp5_;
	_tmp6_ = self->priv->paused;
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "paused");
	_tmp7_ = self->priv->grid;
	if (_tmp7_ != NULL) {
		GtkOverlay* _tmp8_;
		_tmp8_ = self->priv->overlay;
		gtk_overlay_set_child (_tmp8_, NULL);
	}
	_tmp9_ = _g_object_ref0 (_data11_->game);
	_g_object_unref0 (self->game);
	self->game = _tmp9_;
	_tmp10_ = self->game;
	g_signal_connect_object (_tmp10_, "paused-changed", (GCallback) ___lambda10__sudoku_game_paused_changed, self, 0);
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_row_spacing (_tmp11_, 2);
	gtk_grid_set_column_spacing (_tmp11_, 2);
	gtk_grid_set_column_homogeneous (_tmp11_, TRUE);
	gtk_grid_set_row_homogeneous (_tmp11_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp11_;
	_tmp12_ = self->priv->grid;
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "board");
	_tmp13_ = _data11_->game->board;
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _data11_->game->board;
	_tmp17_ = sudoku_board_get_block_cols (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_new0 (GtkGrid*, (_tmp15_ * _tmp18_) + 1);
	blocks = _tmp19_;
	blocks_length1 = _tmp15_;
	blocks_length2 = _tmp18_;
	{
		gint block_row = 0;
		block_row = 0;
		{
			gboolean _tmp20_ = FALSE;
			_tmp20_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				if (!_tmp20_) {
					gint _tmp21_;
					_tmp21_ = block_row;
					block_row = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				_tmp22_ = _data11_->game->board;
				_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
				_tmp24_ = _tmp23_;
				if (!(block_row < _tmp24_)) {
					break;
				}
				{
					gint block_col = 0;
					block_col = 0;
					{
						gboolean _tmp25_ = FALSE;
						_tmp25_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp30_;
							GtkGrid* _tmp31_;
							GtkGrid* _tmp32_;
							GtkGrid* _tmp33_;
							GtkGrid* _tmp34_;
							GtkGrid* _tmp35_;
							GtkGrid* _tmp36_;
							GtkGrid* _tmp37_;
							GtkGrid** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							if (!_tmp25_) {
								gint _tmp26_;
								_tmp26_ = block_col;
								block_col = _tmp26_ + 1;
							}
							_tmp25_ = FALSE;
							_tmp27_ = _data11_->game->board;
							_tmp28_ = sudoku_board_get_block_cols (_tmp27_);
							_tmp29_ = _tmp28_;
							if (!(block_col < _tmp29_)) {
								break;
							}
							_tmp30_ = (GtkGrid*) gtk_grid_new ();
							g_object_ref_sink (_tmp30_);
							block_grid = _tmp30_;
							_tmp31_ = block_grid;
							gtk_grid_set_row_spacing (_tmp31_, 1);
							_tmp32_ = block_grid;
							gtk_grid_set_column_spacing (_tmp32_, 1);
							_tmp33_ = block_grid;
							gtk_grid_set_column_homogeneous (_tmp33_, TRUE);
							_tmp34_ = block_grid;
							gtk_grid_set_row_homogeneous (_tmp34_, TRUE);
							_tmp35_ = block_grid;
							gtk_widget_add_css_class ((GtkWidget*) _tmp35_, "block");
							_tmp36_ = self->priv->grid;
							_tmp37_ = block_grid;
							gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, block_col, block_row, 1, 1);
							_tmp38_ = blocks;
							_tmp38__length1 = blocks_length1;
							_tmp38__length2 = blocks_length2;
							_tmp39_ = block_grid;
							_tmp40_ = _g_object_ref0 (_tmp39_);
							_g_object_unref0 (_tmp38_[(block_row * _tmp38__length2) + block_col]);
							_tmp38_[(block_row * _tmp38__length2) + block_col] = _tmp40_;
							_g_object_unref0 (block_grid);
						}
					}
				}
			}
		}
	}
	_tmp41_ = _data11_->game->board;
	_tmp42_ = sudoku_board_get_rows (_tmp41_);
	_tmp43_ = _tmp42_;
	_tmp44_ = _data11_->game->board;
	_tmp45_ = sudoku_board_get_cols (_tmp44_);
	_tmp46_ = _tmp45_;
	_tmp47_ = g_new0 (SudokuCell*, (_tmp43_ * _tmp46_) + 1);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->cells = _tmp47_;
	self->priv->cells_length1 = _tmp43_;
	self->priv->cells_length2 = _tmp46_;
	{
		gint row = 0;
		row = 0;
		{
			gboolean _tmp48_ = FALSE;
			_tmp48_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				if (!_tmp48_) {
					gint _tmp49_;
					_tmp49_ = row;
					row = _tmp49_ + 1;
				}
				_tmp48_ = FALSE;
				_tmp50_ = _data11_->game->board;
				_tmp51_ = sudoku_board_get_rows (_tmp50_);
				_tmp52_ = _tmp51_;
				if (!(row < _tmp52_)) {
					break;
				}
				{
					gint col = 0;
					col = 0;
					{
						gboolean _tmp53_ = FALSE;
						_tmp53_ = TRUE;
						while (TRUE) {
							Block12Data* _data12_;
							SudokuBoard* _tmp55_;
							gint _tmp56_;
							gint _tmp57_;
							SudokuCell* _tmp58_;
							SudokuCell* _tmp59_;
							SudokuCell* _tmp60_;
							SudokuCell** _tmp61_;
							gint _tmp61__length1;
							gint _tmp61__length2;
							SudokuCell* _tmp62_;
							SudokuCell* _tmp63_;
							GtkGrid** _tmp64_;
							gint _tmp64__length1;
							gint _tmp64__length2;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							GtkGrid* _tmp71_;
							SudokuCell* _tmp72_;
							SudokuBoard* _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
							SudokuBoard* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
							_data12_ = g_slice_new0 (Block12Data);
							_data12_->_ref_count_ = 1;
							_data12_->_data11_ = block11_data_ref (_data11_);
							if (!_tmp53_) {
								gint _tmp54_;
								_tmp54_ = col;
								col = _tmp54_ + 1;
							}
							_tmp53_ = FALSE;
							_tmp55_ = _data11_->game->board;
							_tmp56_ = sudoku_board_get_cols (_tmp55_);
							_tmp57_ = _tmp56_;
							if (!(col < _tmp57_)) {
								block12_data_unref (_data12_);
								_data12_ = NULL;
								break;
							}
							_tmp58_ = sudoku_cell_new (row, col, &self->game);
							g_object_ref_sink (_tmp58_);
							_data12_->cell = _tmp58_;
							_data12_->cell_row = row;
							_data12_->cell_col = col;
							_tmp59_ = _data12_->cell;
							g_signal_connect_data ((GObject*) _tmp59_, "notify::has-focus", (GCallback) _________lambda11__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
							_tmp60_ = _data12_->cell;
							g_signal_connect_data ((GObject*) _tmp60_, "notify::value", (GCallback) _________lambda12__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
							_tmp61_ = self->priv->cells;
							_tmp61__length1 = self->priv->cells_length1;
							_tmp61__length2 = self->priv->cells_length2;
							_tmp62_ = _data12_->cell;
							_tmp63_ = _g_object_ref0 (_tmp62_);
							_g_object_unref0 (_tmp61_[(row * _tmp61__length2) + col]);
							_tmp61_[(row * _tmp61__length2) + col] = _tmp63_;
							_tmp64_ = blocks;
							_tmp64__length1 = blocks_length1;
							_tmp64__length2 = blocks_length2;
							_tmp65_ = _data11_->game->board;
							_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
							_tmp67_ = _tmp66_;
							_tmp68_ = _data11_->game->board;
							_tmp69_ = sudoku_board_get_block_cols (_tmp68_);
							_tmp70_ = _tmp69_;
							_tmp71_ = _tmp64_[((row / _tmp67_) * _tmp64__length2) + (col / _tmp70_)];
							_tmp72_ = _data12_->cell;
							_tmp73_ = _data11_->game->board;
							_tmp74_ = sudoku_board_get_block_cols (_tmp73_);
							_tmp75_ = _tmp74_;
							_tmp76_ = _data11_->game->board;
							_tmp77_ = sudoku_board_get_block_rows (_tmp76_);
							_tmp78_ = _tmp77_;
							gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, col % _tmp75_, row % _tmp78_, 1, 1);
							block12_data_unref (_data12_);
							_data12_ = NULL;
						}
					}
				}
			}
		}
	}
	_tmp79_ = self->priv->overlay;
	_tmp80_ = self->priv->paused;
	gtk_overlay_add_overlay (_tmp79_, (GtkWidget*) _tmp80_);
	_tmp81_ = self->priv->overlay;
	_tmp82_ = self->priv->grid;
	gtk_overlay_set_child (_tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = self->priv->grid;
	gtk_widget_show ((GtkWidget*) _tmp83_);
	_tmp84_ = self->priv->overlay;
	gtk_widget_show ((GtkWidget*) _tmp84_);
	_tmp85_ = self->priv->paused;
	gtk_widget_set_visible ((GtkWidget*) _tmp85_, FALSE);
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (frame);
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return self;
}

SudokuView*
sudoku_view_new (gint frame_size,
                 SudokuGame* game)
{
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, frame_size, game);
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
	g_return_if_fail (self != NULL);
	if (self->selected_row >= 0) {
		_tmp0_ = self->selected_col >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	has_selection = _tmp0_;
	cell_value = -1;
	if (has_selection) {
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp1_ = self->priv->cells;
		_tmp1__length1 = self->priv->cells_length1;
		_tmp1__length2 = self->priv->cells_length2;
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
		_tmp3_ = sudoku_cell_get_value (_tmp2_);
		_tmp4_ = _tmp3_;
		cell_value = _tmp4_;
	}
	{
		gint col_tmp = 0;
		col_tmp = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = col_tmp;
					col_tmp = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->game;
				_tmp8_ = _tmp7_->board;
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
				_tmp10_ = _tmp9_;
				if (!(col_tmp < _tmp10_)) {
					break;
				}
				{
					gint row_tmp = 0;
					row_tmp = 0;
					{
						gboolean _tmp11_ = FALSE;
						_tmp11_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCell** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							SudokuCell* _tmp18_;
							gboolean _tmp19_ = FALSE;
							if (!_tmp11_) {
								gint _tmp12_;
								_tmp12_ = row_tmp;
								row_tmp = _tmp12_ + 1;
							}
							_tmp11_ = FALSE;
							_tmp13_ = self->game;
							_tmp14_ = _tmp13_->board;
							_tmp15_ = sudoku_board_get_rows (_tmp14_);
							_tmp16_ = _tmp15_;
							if (!(row_tmp < _tmp16_)) {
								break;
							}
							_tmp17_ = self->priv->cells;
							_tmp17__length1 = self->priv->cells_length1;
							_tmp17__length2 = self->priv->cells_length2;
							_tmp18_ = _tmp17_[(row_tmp * _tmp17__length2) + col_tmp];
							sudoku_cell_check_warnings (_tmp18_);
							if (has_selection) {
								_tmp19_ = self->priv->_highlighter;
							} else {
								_tmp19_ = FALSE;
							}
							if (_tmp19_) {
								gboolean _tmp20_ = FALSE;
								gboolean _tmp21_ = FALSE;
								SudokuCell** _tmp39_;
								gint _tmp39__length1;
								gint _tmp39__length2;
								SudokuCell* _tmp40_;
								if (col_tmp == self->selected_col) {
									_tmp21_ = TRUE;
								} else {
									_tmp21_ = row_tmp == self->selected_row;
								}
								if (_tmp21_) {
									_tmp20_ = TRUE;
								} else {
									gboolean _tmp22_ = FALSE;
									SudokuGame* _tmp23_;
									SudokuBoard* _tmp24_;
									gint _tmp25_;
									gint _tmp26_;
									SudokuGame* _tmp27_;
									SudokuBoard* _tmp28_;
									gint _tmp29_;
									gint _tmp30_;
									_tmp23_ = self->game;
									_tmp24_ = _tmp23_->board;
									_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
									_tmp26_ = _tmp25_;
									_tmp27_ = self->game;
									_tmp28_ = _tmp27_->board;
									_tmp29_ = sudoku_board_get_block_cols (_tmp28_);
									_tmp30_ = _tmp29_;
									if ((col_tmp / _tmp26_) == (self->selected_col / _tmp30_)) {
										SudokuGame* _tmp31_;
										SudokuBoard* _tmp32_;
										gint _tmp33_;
										gint _tmp34_;
										SudokuGame* _tmp35_;
										SudokuBoard* _tmp36_;
										gint _tmp37_;
										gint _tmp38_;
										_tmp31_ = self->game;
										_tmp32_ = _tmp31_->board;
										_tmp33_ = sudoku_board_get_block_rows (_tmp32_);
										_tmp34_ = _tmp33_;
										_tmp35_ = self->game;
										_tmp36_ = _tmp35_->board;
										_tmp37_ = sudoku_board_get_block_rows (_tmp36_);
										_tmp38_ = _tmp37_;
										_tmp22_ = (row_tmp / _tmp34_) == (self->selected_row / _tmp38_);
									} else {
										_tmp22_ = FALSE;
									}
									_tmp20_ = _tmp22_;
								}
								_tmp39_ = self->priv->cells;
								_tmp39__length1 = self->priv->cells_length1;
								_tmp39__length2 = self->priv->cells_length2;
								_tmp40_ = _tmp39_[(row_tmp * _tmp39__length2) + col_tmp];
								sudoku_cell_set_highlighted_background (_tmp40_, _tmp20_);
								if (cell_value > 0) {
									SudokuCell** _tmp41_;
									gint _tmp41__length1;
									gint _tmp41__length2;
									SudokuCell* _tmp42_;
									SudokuCell** _tmp43_;
									gint _tmp43__length1;
									gint _tmp43__length2;
									SudokuCell* _tmp44_;
									gint _tmp45_;
									gint _tmp46_;
									_tmp41_ = self->priv->cells;
									_tmp41__length1 = self->priv->cells_length1;
									_tmp41__length2 = self->priv->cells_length2;
									_tmp42_ = _tmp41_[(row_tmp * _tmp41__length2) + col_tmp];
									_tmp43_ = self->priv->cells;
									_tmp43__length1 = self->priv->cells_length1;
									_tmp43__length2 = self->priv->cells_length2;
									_tmp44_ = _tmp43_[(row_tmp * _tmp43__length2) + col_tmp];
									_tmp45_ = sudoku_cell_get_value (_tmp44_);
									_tmp46_ = _tmp45_;
									sudoku_cell_set_highlighted_value (_tmp42_, cell_value == _tmp46_);
								} else {
									SudokuCell** _tmp47_;
									gint _tmp47__length1;
									gint _tmp47__length2;
									SudokuCell* _tmp48_;
									_tmp47_ = self->priv->cells;
									_tmp47__length1 = self->priv->cells_length1;
									_tmp47__length2 = self->priv->cells_length2;
									_tmp48_ = _tmp47_[(row_tmp * _tmp47__length2) + col_tmp];
									sudoku_cell_set_highlighted_value (_tmp48_, FALSE);
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_highlights (SudokuView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint col_tmp = 0;
		col_tmp = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = col_tmp;
					col_tmp = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_cols (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(col_tmp < _tmp5_)) {
					break;
				}
				{
					gint row_tmp = 0;
					row_tmp = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = row_tmp;
								row_tmp = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_rows (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(row_tmp < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(row_tmp * _tmp12__length2) + col_tmp];
							sudoku_cell_set_highlighted_value (_tmp13_, FALSE);
							_tmp14_ = self->priv->cells;
							_tmp14__length1 = self->priv->cells_length1;
							_tmp14__length2 = self->priv->cells_length2;
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
							sudoku_cell_set_highlighted_background (_tmp15_, FALSE);
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuGame* _tmp12_;
							SudokuBoard* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->game;
							_tmp13_ = _tmp12_->board;
							sudoku_board_disable_all_earmarks (_tmp13_, i, j);
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_redraw (SudokuView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_check_warnings (_tmp13_);
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_warnings;
	return result;
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_warnings = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_set_show_warnings (_tmp13_, self->priv->_show_warnings);
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_extra_warnings;
	return result;
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_extra_warnings = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_set_show_extra_warnings (_tmp13_, self->priv->_show_extra_warnings);
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_possibilities;
	return result;
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_possibilities = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							_tmp13_->show_possibilities = value;
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_initialize_earmarks;
	return result;
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_initialize_earmarks = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_set_initialize_earmarks (_tmp13_, value);
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighter;
	return result;
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlighter = value;
	if (!self->priv->_highlighter) {
		sudoku_view_clear_highlights (self);
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
}

static gboolean
_sudoku_view___lambda13_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
	g_return_val_if_fail (_self_ != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
	view = _tmp0_;
	_tmp2_ = view;
	if (_tmp2_->selected_row == -1) {
		_tmp1_ = TRUE;
	} else {
		SudokuView* _tmp3_;
		_tmp3_ = view;
		_tmp1_ = _tmp3_->selected_col == -1;
	}
	if (_tmp1_) {
		result = GDK_EVENT_PROPAGATE;
		_g_object_unref0 (view);
		return result;
	}
	_tmp4_ = view;
	if (_tmp4_->selected_row == 0) {
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
		_tmp5_ = view;
		_tmp6_ = _tmp5_->priv->cells;
		_tmp6__length1 = _tmp5_->priv->cells_length1;
		_tmp6__length2 = _tmp5_->priv->cells_length2;
		_tmp7_ = view;
		_tmp8_ = _tmp6_[(8 * _tmp6__length2) + _tmp7_->selected_col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
		_tmp9_ = view;
		_tmp10_ = _tmp9_->priv->cells;
		_tmp10__length1 = _tmp9_->priv->cells_length1;
		_tmp10__length2 = _tmp9_->priv->cells_length2;
		_tmp11_ = view;
		_tmp12_ = view;
		_tmp13_ = _tmp10_[((_tmp11_->selected_row - 1) * _tmp10__length2) + _tmp12_->selected_col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
	}
	result = GDK_EVENT_STOP;
	_g_object_unref0 (view);
	return result;
}

static gboolean
__sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda13_ (widget);
	return result;
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
	g_return_val_if_fail (_self_ != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
	view = _tmp0_;
	_tmp2_ = view;
	if (_tmp2_->selected_row == -1) {
		_tmp1_ = TRUE;
	} else {
		SudokuView* _tmp3_;
		_tmp3_ = view;
		_tmp1_ = _tmp3_->selected_col == -1;
	}
	if (_tmp1_) {
		result = GDK_EVENT_PROPAGATE;
		_g_object_unref0 (view);
		return result;
	}
	_tmp4_ = view;
	if (_tmp4_->selected_row == 8) {
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
		_tmp5_ = view;
		_tmp6_ = _tmp5_->priv->cells;
		_tmp6__length1 = _tmp5_->priv->cells_length1;
		_tmp6__length2 = _tmp5_->priv->cells_length2;
		_tmp7_ = view;
		_tmp8_ = _tmp6_[(0 * _tmp6__length2) + _tmp7_->selected_col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
		_tmp9_ = view;
		_tmp10_ = _tmp9_->priv->cells;
		_tmp10__length1 = _tmp9_->priv->cells_length1;
		_tmp10__length2 = _tmp9_->priv->cells_length2;
		_tmp11_ = view;
		_tmp12_ = view;
		_tmp13_ = _tmp10_[((_tmp11_->selected_row + 1) * _tmp10__length2) + _tmp12_->selected_col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
	}
	result = GDK_EVENT_STOP;
	_g_object_unref0 (view);
	return result;
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
	return result;
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
	g_return_val_if_fail (_self_ != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
	view = _tmp0_;
	_tmp2_ = view;
	if (_tmp2_->selected_row == -1) {
		_tmp1_ = TRUE;
	} else {
		SudokuView* _tmp3_;
		_tmp3_ = view;
		_tmp1_ = _tmp3_->selected_col == -1;
	}
	if (_tmp1_) {
		result = GDK_EVENT_PROPAGATE;
		_g_object_unref0 (view);
		return result;
	}
	_tmp4_ = view;
	if (_tmp4_->selected_col == 0) {
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
		_tmp5_ = view;
		_tmp6_ = _tmp5_->priv->cells;
		_tmp6__length1 = _tmp5_->priv->cells_length1;
		_tmp6__length2 = _tmp5_->priv->cells_length2;
		_tmp7_ = view;
		_tmp8_ = _tmp6_[(_tmp7_->selected_row * _tmp6__length2) + 8];
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
		_tmp9_ = view;
		_tmp10_ = _tmp9_->priv->cells;
		_tmp10__length1 = _tmp9_->priv->cells_length1;
		_tmp10__length2 = _tmp9_->priv->cells_length2;
		_tmp11_ = view;
		_tmp12_ = view;
		_tmp13_ = _tmp10_[(_tmp11_->selected_row * _tmp10__length2) + (_tmp12_->selected_col - 1)];
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
	}
	result = GDK_EVENT_STOP;
	_g_object_unref0 (view);
	return result;
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
	return result;
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
	g_return_val_if_fail (_self_ != NULL, FALSE);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
	view = _tmp0_;
	_tmp2_ = view;
	if (_tmp2_->selected_row == -1) {
		_tmp1_ = TRUE;
	} else {
		SudokuView* _tmp3_;
		_tmp3_ = view;
		_tmp1_ = _tmp3_->selected_col == -1;
	}
	if (_tmp1_) {
		result = GDK_EVENT_PROPAGATE;
		_g_object_unref0 (view);
		return result;
	}
	_tmp4_ = view;
	if (_tmp4_->selected_col == 8) {
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
		_tmp5_ = view;
		_tmp6_ = _tmp5_->priv->cells;
		_tmp6__length1 = _tmp5_->priv->cells_length1;
		_tmp6__length2 = _tmp5_->priv->cells_length2;
		_tmp7_ = view;
		_tmp8_ = _tmp6_[(_tmp7_->selected_row * _tmp6__length2) + 0];
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
		_tmp9_ = view;
		_tmp10_ = _tmp9_->priv->cells;
		_tmp10__length1 = _tmp9_->priv->cells_length1;
		_tmp10__length2 = _tmp9_->priv->cells_length2;
		_tmp11_ = view;
		_tmp12_ = view;
		_tmp13_ = _tmp10_[(_tmp11_->selected_row * _tmp10__length2) + (_tmp12_->selected_col + 1)];
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
	}
	result = GDK_EVENT_STOP;
	_g_object_unref0 (view);
	return result;
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
	return result;
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	up_func = __sudoku_view___lambda13__gtk_shortcut_func;
	up_func_target = NULL;
	up_func_target_destroy_notify = NULL;
	down_func = __sudoku_view___lambda14__gtk_shortcut_func;
	down_func_target = NULL;
	down_func_target_destroy_notify = NULL;
	left_func = __sudoku_view___lambda15__gtk_shortcut_func;
	left_func_target = NULL;
	left_func_target_destroy_notify = NULL;
	right_func = __sudoku_view___lambda16__gtk_shortcut_func;
	right_func_target = NULL;
	right_func_target_destroy_notify = NULL;
	_tmp0_ = up_func;
	_tmp0__target = up_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
	_tmp1_ = up_func;
	_tmp1__target = up_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
	_tmp2_ = up_func;
	_tmp2__target = up_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
	_tmp3_ = down_func;
	_tmp3__target = down_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
	_tmp4_ = down_func;
	_tmp4__target = down_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
	_tmp5_ = down_func;
	_tmp5__target = down_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
	_tmp6_ = left_func;
	_tmp6__target = left_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
	_tmp7_ = left_func;
	_tmp7__target = left_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
	_tmp8_ = left_func;
	_tmp8__target = left_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
	_tmp9_ = right_func;
	_tmp9__target = right_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
	_tmp10_ = right_func;
	_tmp10__target = right_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
	_tmp11_ = right_func;
	_tmp11__target = right_func_target;
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
	right_func = NULL;
	right_func_target = NULL;
	right_func_target_destroy_notify = NULL;
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
	left_func = NULL;
	left_func_target = NULL;
	left_func_target_destroy_notify = NULL;
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
	down_func = NULL;
	down_func_target = NULL;
	down_func_target_destroy_notify = NULL;
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
	up_func = NULL;
	up_func_target = NULL;
	up_func_target_destroy_notify = NULL;
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
	self->priv = sudoku_view_get_instance_private (self);
	self->priv->previous_board_broken_state = FALSE;
	self->selected_row = 0;
	self->selected_col = 0;
	self->priv->_show_warnings = FALSE;
	self->priv->_show_extra_warnings = FALSE;
	self->priv->_show_possibilities = FALSE;
	self->priv->_initialize_earmarks = FALSE;
	self->priv->_highlighter = FALSE;
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
	_g_object_unref0 (self->game);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->paused);
	_g_object_unref0 (self->priv->overlay);
	_g_object_unref0 (self->priv->grid);
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
		break;
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
		break;
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

